# -*- coding:utf-8 -*-
#
__script__ = "PyImgViewer"
__ver__    = "1.00(1)"
__author__ = 'masa'
__web__    = "http://masaland.cocolog-nifty.com/"
__Copyright__ = '(C) 2014,2015 masa'


import sys
import os
if not hasattr(sys, "setdefaultencoding"):
    wk = sys.stdout
    reload(sys)
    sys.stdout = wk
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import appuifw
import e32
import graphics
#from key_codes import *
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow
from key_codes import EKeyUpArrow
from key_codes import EKeyDownArrow
from key_codes import EKeySelect
from key_codes import EKeyEnter

try:
    from PyFbuiutil import Fbrowser
    EXIT_FLG = 0
except:
    appuifw.query(unicode("PyFbuiutil をインストールして下さい", "utf-8"), "query")
    EXIT_FLG = 1

###
INI_FILE = 'E:\\Data\\masa\\PyImgViewer.conf'
#------
DEF_PATH  = 'E:\\Images\\'
Show_Interval = 3
Auto_Rotate = 1
Screen_Color = (220,210,170) #薄い茶色
Show_in_lowercase = 1 #0:as is 1:in lower case 2:in upper case
Show_Directional_pad = 0
#------
TRACE = 0  # for debug
###


class viewer:
    
    def __init__(self):
        self.Fb = Fbrowser("Dir Select")
        self.viewing = 1
        self.in_path = ''
        self.def_path = unicode(DEF_PATH)
        self.script_lock = e32.Ao_lock()
        self.pointer = 0
        self.file_list = []
        self.choices_list = []
        self.slideshow_mode = 0
        self.slideshow_timer = e32.Ao_timer()
        self.slideshow_start_point_reminder = 0
        self.show_interval = Show_Interval
        self.slideshow_loop = 0
        self.display_img = ''
        self.state = 0
        self.auto_rotate = Auto_Rotate
        self.screen_color = Screen_Color
        self.show_in_lower = Show_in_lowercase
        self.show_directional_pad = Show_Directional_pad


    def rot_land(self):
        appuifw.app.orientation='landscape'
        appuifw.app.screen = "full"


    def rot_port(self):
        appuifw.app.orientation='portrait'
        appuifw.app.screen = "normal"


    def rot_clear(self):
        appuifw.app.orientation='automatic'
        appuifw.app.screen = "normal"


    def rot_normal(self):
        appuifw.app.screen = "normal"


    def rot_full(self):
        appuifw.app.screen = "full"


    def confread(self):
        # 設定ファイルパス
        if os.path.isdir("E:\\DATA") == True:
            if os.path.isdir("E:\\DATA\\Masa") == False:
                os.mkdir("E:\\DATA\\Masa")

        # 設定の読込
        if os.path.isfile(INI_FILE) == True:
            fileobj = open(INI_FILE, "r")
            setting_text = fileobj.read()
            fileobj.close()
            setting_list = setting_text.split(',')

            # デフォルトディレクトリ
            if len(setting_list[0]) > 0:
                if os.path.isdir(setting_list[0]) == True:
                    self.def_path = unicode(setting_list[0])
                else:
                    appuifw.query(unicode('No such dir \n check input path'),'query')
            # スライドショーインターバル
            if len(setting_list[1]) > 0:
                self.show_interval = int(setting_list[1])
            # オートローテート
            if len(setting_list[2]) > 0:
                self.auto_rotate = int(setting_list[2])
            # スクリーンカラー
            if len(setting_list[3]) > 0 :
                wk = (setting_list[3]).split("/")
                if len(wk) >= 3:
                    self.screen_color = (int(wk[0]), int(wk[1]), int(wk[2]))
            # 大文字小文字表示指定
            if len(setting_list[4]) > 0:
                self.show_in_lower = int(setting_list[4])
            # ４方向カーソルキー表示
            if len(setting_list[5]) > 0:
                self.show_directional_pad = int(setting_list[5])

        self.in_path = self.def_path[:]



    def saveConfig(self):
        save_data = "%s,%s,%s,%s/%s/%s,%s,%s" % \
                (self.def_path.encode('UTF-8'), str(self.show_interval), \
                 str(self.auto_rotate), str(self.screen_color[0]), \
                 str(self.screen_color[1]),str(self.screen_color[2]), \
                 str(self.show_in_lower), str(self.show_directional_pad))

        # ディレクトリチェック
        if os.path.isdir("E:\\DATA\\Masa") == False:
            return False

        fileobj = open(INI_FILE, "w")
        fileobj.write(save_data)
        fileobj.close()



    def setting(self):
        # 設定
        wk = "%s,%s,%s" % (self.screen_color[0], self.screen_color[1], self.screen_color[2])
        form = appuifw.Form([
(unicode("Default Directory","utf-8"),"text", self.def_path,),

(unicode("Slide show interval(sec)","utf-8"),"number", self.show_interval),

(unicode("Auto rotate","utf-8"), "combo",([unicode("OFF", "utf-8"), unicode("ON", "utf-8")], self.auto_rotate)),

(unicode("Screen color","utf-8"),"text", unicode(wk,"utf-8")),

(unicode("Show in lower case","utf-8"), "combo",([unicode("OFF", "utf-8"), unicode("Lower case", "utf-8"), unicode("Upper case", "utf-8")], self.show_in_lower)),

(unicode("Show Directional pad","utf-8"), "combo",([unicode("OFF", "utf-8"), unicode("ON", "utf-8")], self.show_directional_pad))

], appuifw.FFormDoubleSpaced)
        form.execute()

        # 設定情報更新
        # デフォルトディレクトリ
        if os.path.isdir(form[0][2]) == True:
            wk = unicode(form[0][2])
            if self.def_path != wk:
                self.def_path = wk
                self.in_path = self.def_path[:]
        else:
            appuifw.query(unicode('No such dir \n check input path'),'query')
        # スライドショーインターバル
        self.show_interval  = int(form[1][2])
        # オートローテート
        self.auto_rotate = int(form[2][2][1])
        # スクリーンカラー
        wk = (form[3][2]).split(",")
        if len(wk) >= 3:
            self.screen_color = (int(wk[0]), int(wk[1]), int(wk[2]))
        # 大文字小文字表示指定
        self.show_in_lower = int(form[4][2][1])
        # ４方向カーソルキー表示
        self.show_directional_pad = int(form[5][2][1])

        # 設定保存
        self.saveConfig()


    def run(self):
        self.confread()
        appuifw.app.exit_key_handler = None
        appuifw.app.screen='normal'
        oldtitle=appuifw.app.title
        oldbody = appuifw.app.body

        self.canvas=appuifw.Canvas(redraw_callback=lambda rect:self.redraw_cb())
        appuifw.app.body=self.canvas
        appuifw.app.title=unicode(__script__)
        self.rot_port()
        self.set_mainmenu()
        appuifw.app.body = self.canvas #*

        while self.viewing:
            self.draw_state()
            self.script_lock.wait()
        appuifw.app.title=oldtitle
        self.rot_clear()
        appuifw.app.body = oldbody


    def set_mainmenu(self):
        appuifw.app.exit_key_handler = lambda:self.do_exit()
        appuifw.app.menu = [
                (unicode('File', 'utf-8'), self.open_file), 
                (unicode('Settings', 'utf-8'),self.setting),
                (unicode('About', 'utf-8'),self.about),
                (unicode('Exit', 'utf-8'), self.do_exit)] 
        self.canvas.bind(EKeyLeftArrow,  self.do_dummy)
        self.canvas.bind(EKeyRightArrow, self.do_dummy)
        self.canvas.bind(EKeyUpArrow   , self.do_dummy)
        self.canvas.bind(EKeyDownArrow , self.do_dummy)
        self.canvas.bind(EKeySelect    , self.do_dummy)
        self.canvas.bind(EKeyEnter     , self.do_dummy)
        self.state = 0


    def set_submenu(self):
        appuifw.app.exit_key_handler = lambda:self.cancel()
        appuifw.app.menu = [
              (unicode('Goto', 'utf-8'),self.gotonum),
              (unicode('Cancel', 'utf-8'),self.cancel),
              (unicode('Slide show', 'utf-8'),
               ((unicode('Start (one time)', 'utf-8'), lambda:self.start_slideshow(0)),
                (unicode('Start (loop)', 'utf-8'), lambda:self.start_slideshow(1)))),
              (unicode('Exit', 'utf-8'), self.do_exit)]
        self.canvas.bind(EKeyLeftArrow,  self.moveleft)
        self.canvas.bind(EKeyRightArrow, self.moveright)
        self.canvas.bind(EKeyUpArrow   , self.moveup)
        self.canvas.bind(EKeyDownArrow , self.movedown)
        self.canvas.bind(EKeySelect    , self.enterkey)
        self.canvas.bind(EKeyEnter     , self.enterkey)
        self.state = 1


    def set_submenu_slideshow(self):
        appuifw.app.exit_key_handler = lambda:self.stop_slideshow()
        appuifw.app.menu = [(unicode('Stop', 'utf-8'),self.stop_slideshow),
                            (unicode('Exit', 'utf-8'), self.do_exit)]


    def open_file(self):
        self.list_setup()
        if len(self.file_list) > 0:
            self.rot_land()
            self.set_submenu()
        appuifw.app.body = self.canvas #*
        self.script_lock.signal()


    def gotonum(self):
        jnum = appuifw.query(unicode("Go to:"), "number", 1)
        if jnum==None:
            self.script_lock.signal()
            return

        if jnum <= 1:
            self.pointer = 0
        elif jnum >= len(self.file_list):
            self.pointer = len(self.file_list) - 1
        else:
            self.pointer = jnum-1
        self.script_lock.signal()


    def moveup(self):
        if self.pointer > 0:
            self.pointer = self.pointer -1
        self.script_lock.signal()


    def movedown(self):
        if self.pointer < len(self.file_list) -1:
            self.pointer = self.pointer +1
        self.script_lock.signal()


    def moveleft(self):
        if self.pointer > 0:
            self.pointer = self.pointer -1
        self.script_lock.signal()



    def moveright(self):
        if self.pointer < len(self.file_list) -1:
            self.pointer = self.pointer +1
        self.script_lock.signal()


    def enterkey(self):
        self.script_lock.signal()


    def cancel(self):
        self.trace('c1')
        self.rot_port()
        self.set_mainmenu()
        self.display_img = '' #*0004

        self.reselect_file()
        if len(self.file_list) > 0:
            self.rot_land()
            self.set_submenu()
        appuifw.app.body = self.canvas #*
        self.script_lock.signal()
        self.trace('c2')


    def start_slideshow(self, flg=0):
        self.set_submenu_slideshow()
        self.slideshow_loop = flg
        self.slideshow_mode = 1
        self.slideshow_start_point_reminder = self.pointer
        self.start_slideshow_timer() #* *1 need *1 or *2 to start timer
#        self.script_lock.signal()   #* *2


    def start_slideshow_timer(self):
        self.slideshow_timer.cancel()
        self.slideshow_timer.after(self.show_interval, self.slideshow)


    def slideshow(self):
        if self.pointer < len(self.file_list) -1:
            self.pointer = self.pointer + 1
            self.script_lock.signal()
        elif self.slideshow_loop:
            self.pointer = self.slideshow_start_point_reminder
            self.script_lock.signal()
        else:
             self.stop_slideshow()
        #Reset the user inactivity time, turning the backlight on
        e32.reset_inactivity()


    def stop_slideshow(self):
        self.slideshow_timer.cancel()
        self.set_submenu()
        self.state = 2
        self.slideshow_mode = 0


    def do_exit(self):
        appuifw.app.exit_key_handler = None
        self.viewing=0
        self.script_lock.signal()


    def do_dummy(self):
        pass


    def trace(self, flg):
        if TRACE:
            print "%s %s %02d %02d" % (flg,self.state,len(self.file_list),\
                self.pointer),("%s" % self.display_img)[25:]


    def draw_state(self):
        self.trace('a1')

        if len(self.file_list) == 0 or self.state == 0:
            return #JPGの無いフォルダのとき必要

        if self.show_directional_pad:
            appuifw.app.directional_pad = True
        else:
            appuifw.app.directional_pad = False

        gwidth, gheight = self.canvas.size
        clear_img = graphics.Image.new((gwidth,gheight))
        clear_img.clear((50,50,50))

        file_name = self.file_list[self.pointer]
        FILE = os.path.join(self.in_path ,file_name)
        appuifw.app.title = file_name # display image file name

        try:
            img = graphics.Image.open(FILE)
        except:
            img = graphics.Image.new((gwidth,gheight))
            img.clear(self.screen_color)
            img.rectangle((10, 40, 300, 170),fill=(220, 250, 160))
            img.text((20, 60), unicode('Image open error', 'utf-8'), \
               fill=(0,0,0), font='dense')
            img.text((20,80), unicode('Please check image type', 'utf-8'), \
               fill=(0,0,0), font='dense')
            img.text((30,100), unicode('baseline   : OK', 'utf-8'), \
               fill=(0,0,0), font='dense')
            img.text((30,120), unicode('progressive: NG', 'utf-8'), \
               fill=(0,0,0), font='dense')
            img.text((20,160), file_name, fill=(0,0,0), font='dense')
        img_width, img_height = img.size

        if self.auto_rotate == 1:
            if img_height > img_width :
                img = img.transpose(graphics.ROTATE_90)
                img_width, img_height = img.size

        self.display_img = img.resize((gwidth,gheight),keepaspect=1)
        appuifw.app.body = self.canvas
#        self.canvas.blit(clear_img)
        self.canvas.blit(self.display_img)

        self.state = 2
        if self.slideshow_mode:
            self.start_slideshow_timer()

        self.trace('a2')


    def redraw_cb(self):

        self.trace('r1')

        if self.show_directional_pad:
            appuifw.app.directional_pad = True
        else:
            appuifw.app.directional_pad = False

        gwidth, gheight = self.canvas.size
        clear_img = graphics.Image.new((gwidth,gheight))
        if self.state == 2:
            clear_img.clear((50,50,50))
            self.canvas.blit(clear_img)
            self.canvas.blit(self.display_img)
        elif self.state == 1:
            if self.display_img:
                clear_img.clear((50,50,50))
                self.canvas.blit(clear_img)
                self.canvas.blit(self.display_img)
        elif self.state == 0:
            clear_img.clear(self.screen_color)
            clear_img.text((20,80), unicode('Image Viewer', 'utf-8'), \
                            fill=(0,0,0), font='title')
            self.canvas.blit(clear_img)
        self.trace('r2')


    def list_setup(self):
        appuifw.app.title=unicode(__script__)
        self.trace('s1')

        rtn_path = self.Fb.select(default_path=self.in_path)
        if rtn_path == None:
            self.rot_port()
            self.set_mainmenu()
            return

        else:
            if not rtn_path[0] == '':
                self.in_path = unicode(rtn_path[0])

        if not os.path.isdir(self.in_path):
            rtn = appuifw.query(unicode('No such dir \n need check \n input path'),'query')
            self.do_exit()
            return

        self.file_list = [x.decode('utf-8') for x in os.listdir(self.in_path) \
                if (os.path.splitext(x)[1][1:3]).lower() == "jp"]
        if not self.file_list: # no image file in in_path
            rtn = appuifw.query(unicode('No image file \n in in_path'),'query')
            self.rot_port()     #* don't remove
            self.set_mainmenu() #* don't remove
            return
        self.file_list_sort()

        if   self.show_in_lower == 1:
            self.choices_list = [dWK.lower() for dWK in self.file_list]
        elif self.show_in_lower == 2:
            self.choices_list = [dWK.upper() for dWK in self.file_list]
        else:
            self.choices_list = self.file_list
        index = appuifw.selection_list(choices=self.choices_list, search_field=1)
        
        if index == None:
            self.file_list = []
            self.display_img = ''
            self.list_setup()
        else:
            self.pointer = index
        self.trace('s2')


    def reselect_file(self):
        index = appuifw.selection_list(choices=self.choices_list, search_field=1)

        if index == None:
            self.file_list = []
            self.display_img = ''
            self.list_setup()
        else:
            self.pointer = index


    def file_list_sort(self):
        list_dic = {}
        for dWK in self.file_list:
            list_dic[dWK.lower()] = dWK
        key_list = list_dic.keys()
        key_list.sort()
        self.file_list = []
        self.file_list = [list_dic[dWK] for dWK in key_list]


    def about(self):
        msg =     (__script__) \
         + '\n' + ('Ver_' + __ver__) \
         + '\n' + (__Copyright__) \
         + '\n' + (__web__ )
        appuifw.query(unicode(msg, "utf-8"), "query")
        self.script_lock.signal()


if __name__ == '__main__':
    if EXIT_FLG == 0:
        window=viewer()
        window.run()

#    sys.exit()

